<?php defined('BASEPATH') OR exit('No direct script access allowed'); 
////////////old
class Auth extends CI_Controller {
    //dfff
	function __construct()
	{
		parent::__construct();
		$this->load->library('ion_auth');
		$this->load->library('form_validation');
		$this->load->helper('url');

		// Load MongoDB library instead of native db driver if required
		$this->config->item('use_mongodb', 'ion_auth') ?
		$this->load->library('mongo_db') :

		$this->load->database();

		$this->form_validation->set_error_delimiters($this->config->item('error_start_delimiter', 'ion_auth'), $this->config->item('error_end_delimiter', 'ion_auth'));

		$this->lang->load('auth');
		$this->load->helper('language');
	}

	//redirect if needed, otherwise display the user list
	function index()
	{

		if (!$this->ion_auth->logged_in())
		{
			//redirect them to the login page
			redirect('auth/login', 'refresh');
		}
		elseif (!$this->ion_auth->is_admin()) //remove this elseif if you want to enable this for non-admins
		{
			//redirect them to the home page because they must be an administrator to view this
			return show_error('You must be an administrator to view this page.');
		}
		else
		{
			//set the flash data error message if there is one
			$this->data['message'] = (validation_errors()) ? validation_errors() : $this->session->flashdata('message');

			//list the users
			$this->data['users'] = $this->ion_auth->users()->result();
			foreach ($this->data['users'] as $k => $user)
			{
				$this->data['users'][$k]->groups = $this->ion_auth->get_users_groups($user->id)->result();
			}

			$this->_render_page('auth/index', $this->data);
		}
	}
        
        //added by Fernando
        //view: view to display
        //mode: loggedin or logged out
        function showView($view)
        {
         //load subviews
         $this->data['subview'] = 'home';
         //load view based on mode
         $this->data['subview'] = 'membership/' . $view;
                
         //check if user is logged in 
         if ($this->ion_auth->logged_in() && $this->ion_auth->is_admin())
		{
	             //load the view passing $data values
                     $this->load->view("layouts/main_admin", $this->data);
		}
         else if ($this->ion_auth->logged_in() && !$this->ion_auth->is_admin())
		{
		     //load the view passing $data values
                     $this->load->view("layouts/main_logged_in", $this->data);
		}
         else
                {
                     //load the view passing $data values
                     $this->load->view("layouts/main", $this->data);
                }
                
        }
        
        //NEW
        //return all user ids in db
        function allUsers()
        {
            //load the model
	   $this->load->model('search_model');
           $this->data['user_list'] = $this->search_model->list_all_users(); // get results array from model
        }
        
        //return all user fields in db
        function allFields()
        {
            //load the model
	   $this->load->model('search_model');
           
           //Values to Insert in Head of Table
	   $this->data['fields'] = array(
			'id' => 'ID',
			'first_name' => 'First Name',
			'last_name' => 'Last Name'
		);
        
           $this->data['membersforview'] = $this->search_model->list_all_fields(); // get results array from model
        }
        
	//log the user in
	function login()
	{
		$this->data['title'] = "Login";

		//validate form input
		$this->form_validation->set_rules('identity', 'Identity', 'required');
		$this->form_validation->set_rules('password', 'Password', 'required');
                
                //If you press the submit button
                if ($this->form_validation->run() == true)
		{
			//check to see if the user is logging in
			//check for "remember me"
			$remember = (bool) $this->input->post('remember');

			if ($this->ion_auth->login($this->input->post('identity'), $this->input->post('password'), $remember))
			{
				//if the login is successful
				//redirect them back to the home page
				$this->session->set_flashdata('message', $this->ion_auth->messages());
				redirect('home', 'refresh');
			}
			else
			{
				//if the login was un-successful
				//redirect them back to the login page
				$this->session->set_flashdata('message', $this->ion_auth->errors());
				redirect('auth/login', 'refresh'); //use redirects instead of loading views for compatibility with MY_Controller libraries
			}
		}
		else
		{
			//the user is not logging in so display the login page
			//set the flash data error message if there is one
			$this->data['message'] = (validation_errors()) ? validation_errors() : $this->session->flashdata('message');

			$this->data['identity'] = array('name' => 'identity',
				'id' => 'identity',
				'type' => 'text',
				'value' => $this->form_validation->set_value('identity'),
			);
			$this->data['password'] = array('name' => 'password',
				'id' => 'password',
				'type' => 'password',
			);
                       
                        //display loginView
                        $this->showView('login');
		}
	}

	//log the user out
	function logout()
	{
		$this->data['title'] = "Logout";

		//log the user out
		$logout = $this->ion_auth->logout();

		//redirect them to the login page
		$this->session->set_flashdata('message', $this->ion_auth->messages());
		redirect('auth/login', 'refresh');
	}

	//change password
	function change_password()
	{
		$this->form_validation->set_rules('old', $this->lang->line('change_password_validation_old_password_label'), 'required');
		$this->form_validation->set_rules('new', $this->lang->line('change_password_validation_new_password_label'), 'required|min_length[' . $this->config->item('min_password_length', 'ion_auth') . ']|max_length[' . $this->config->item('max_password_length', 'ion_auth') . ']|matches[new_confirm]');
		$this->form_validation->set_rules('new_confirm', $this->lang->line('change_password_validation_new_password_confirm_label'), 'required');

		if (!$this->ion_auth->logged_in())
		{
			redirect('auth/login', 'refresh');
		}

		$user = $this->ion_auth->user()->row();

		if ($this->form_validation->run() == false)
		{
			//display the form
			//set the flash data error message if there is one
			$this->data['message'] = (validation_errors()) ? validation_errors() : $this->session->flashdata('message');

			$this->data['min_password_length'] = $this->config->item('min_password_length', 'ion_auth');
			$this->data['old_password'] = array(
				'name' => 'old',
				'id'   => 'old',
				'type' => 'password',
			);
			$this->data['new_password'] = array(
				'name' => 'new',
				'id'   => 'new',
				'type' => 'password',
				'pattern' => '^.{'.$this->data['min_password_length'].'}.*$',
			);
			$this->data['new_password_confirm'] = array(
				'name' => 'new_confirm',
				'id'   => 'new_confirm',
				'type' => 'password',
				'pattern' => '^.{'.$this->data['min_password_length'].'}.*$',
			);
			$this->data['user_id'] = array(
				'name'  => 'user_id',
				'id'    => 'user_id',
				'type'  => 'hidden',
				'value' => $user->id,
			);
                        
                        //display loginView
                        $this->showView('change_password');
		}
		else
		{
			$identity = $this->session->userdata($this->config->item('identity', 'ion_auth'));

			$change = $this->ion_auth->change_password($identity, $this->input->post('old'), $this->input->post('new'));

			if ($change)
			{
				//if the password was successfully changed
				$this->session->set_flashdata('message', $this->ion_auth->messages());
				$this->logout();
			}
			else
			{
				$this->session->set_flashdata('message', $this->ion_auth->errors());
				redirect('auth/change_password', 'refresh');
			}
		}
	}

	//forgot password
	function forgot_password()
	{
		$this->form_validation->set_rules('email', $this->lang->line('forgot_password_validation_email_label'), 'required');
		if ($this->form_validation->run() == false)
		{
			//setup the input
			$this->data['email'] = array('name' => 'email',
				'id' => 'email',
			);

			if ( $this->config->item('identity', 'ion_auth') == 'username' ){
				$this->data['identity_label'] = $this->lang->line('forgot_password_username_identity_label');
			}
			else
			{
				$this->data['identity_label'] = $this->lang->line('forgot_password_email_identity_label');
			}

			//set any errors and display the form
			$this->data['message'] = (validation_errors()) ? validation_errors() : $this->session->flashdata('message');
			//$this->_render_page('auth/forgot_password', $this->data);
                        $this->showView('forgot_password');
		}
		else
		{
			// get identity for that email
            $identity = $this->ion_auth->where('email', strtolower($this->input->post('email')))->users()->row();
            if(empty($identity)) 
            {
                $this->ion_auth->set_message('forgot_password_email_not_found');
                $this->session->set_flashdata('message', $this->ion_auth->messages());
                redirect("auth/forgot_password", 'refresh');
            }
            
			//run the forgotten password method to email an activation code to the user
			$forgotten = $this->ion_auth->forgotten_password($identity->{$this->config->item('identity', 'ion_auth')});

			if ($forgotten)
			{
				//if there were no errors
				$this->session->set_flashdata('message', $this->ion_auth->messages());
				redirect("auth/login", 'refresh'); //we should display a confirmation page here instead of the login page
			}
			else
			{
				$this->session->set_flashdata('message', $this->ion_auth->errors());
				redirect("auth/forgot_password", 'refresh');
			}
		}
	}

	//reset password - final step for forgotten password
	public function reset_password($code = NULL)
	{
		if (!$code)
		{
			show_404();
		}

		$user = $this->ion_auth->forgotten_password_check($code);

		if ($user)
		{
			//if the code is valid then display the password reset form

			$this->form_validation->set_rules('new', $this->lang->line('reset_password_validation_new_password_label'), 'required|min_length[' . $this->config->item('min_password_length', 'ion_auth') . ']|max_length[' . $this->config->item('max_password_length', 'ion_auth') . ']|matches[new_confirm]');
			$this->form_validation->set_rules('new_confirm', $this->lang->line('reset_password_validation_new_password_confirm_label'), 'required');

			if ($this->form_validation->run() == false)
			{
				//display the form

				//set the flash data error message if there is one
				$this->data['message'] = (validation_errors()) ? validation_errors() : $this->session->flashdata('message');

				$this->data['min_password_length'] = $this->config->item('min_password_length', 'ion_auth');
				$this->data['new_password'] = array(
					'name' => 'new',
					'id'   => 'new',
				'type' => 'password',
					'pattern' => '^.{'.$this->data['min_password_length'].'}.*$',
				);
				$this->data['new_password_confirm'] = array(
					'name' => 'new_confirm',
					'id'   => 'new_confirm',
					'type' => 'password',
					'pattern' => '^.{'.$this->data['min_password_length'].'}.*$',
				);
				$this->data['user_id'] = array(
					'name'  => 'user_id',
					'id'    => 'user_id',
					'type'  => 'hidden',
					'value' => $user->id,
				);
				//$this->data['csrf'] = $this->_get_csrf_nonce();
				$this->data['code'] = $code;

				//render
				//$this->_render_page('auth/reset_password', $this->data);
                                $this->showView('reset_password');
			}
			else
			{
				// do we have a valid request?
				//if ($this->_valid_csrf_nonce() === FALSE || $user->id != $this->input->post('user_id'))
				//{

					//something fishy might be up
				//	$this->ion_auth->clear_forgotten_password_code($code);

				//	show_error($this->lang->line('error_csrf'));

				//}
				//else
				//{
					// finally change the password
					$identity = $user->{$this->config->item('identity', 'ion_auth')};

					$change = $this->ion_auth->reset_password($identity, $this->input->post('new'));

					if ($change)
					{
						//if the password was successfully changed
						$this->session->set_flashdata('message', $this->ion_auth->messages());
						$this->logout();
					}
					else
					{
						$this->session->set_flashdata('message', $this->ion_auth->errors());
						redirect('auth/reset_password/' . $code, 'refresh');
					}
				//}
			}
		}
		else
		{
			//if the code is invalid then send them back to the forgot password page
			$this->session->set_flashdata('message', $this->ion_auth->errors());
			redirect("auth/forgot_password", 'refresh');
		}
	}

	//activate the user
	//function activate($id, $code=false)
        //id is the id of the user to activate
        function activate($query_id = 0, $sort_by = 'first_name', $sort_order = 'asc', $offset = 0)
	{
            //grab id from the input box
            $id = $this->input->post('activation_id');
            $user = $this->ion_auth->user($id)->row();
                
            $this->load->library('form_validation');
		//$this->form_validation->set_rules('confirm', $this->lang->line('deactivate_validation_confirm_label'), 'required');
		$this->form_validation->set_rules('activation_id', 'User ID', 'required|alpha_numeric|xss_clean');
                
            if ($this->form_validation->run() == FALSE)
		{
			// insert csrf check
			$this->data['csrf'] = $this->_get_csrf_nonce();
			$this->data['user'] = $this->ion_auth->user($id)->row();

                        
                                //Search Table Section
                    //Limit on items to show on table
        $limit = 5;
        
        //Values to Insert in Head of Table
	$this->data['fields'] = array(
                        'id'           => 'ID:',
			'first_name' => 'First Name:',
			'last_name' => 'Last Name:',
                        'email'      => 'Email:',
                        'company' => 'Company:',
                        'position' => 'Position:',
                        'country'  => 'Country:',
                        'activated' => 'Active:',
		);
                
        $category = 'first_name';
        //$a = '';
         
         $this->data['query_id'] = $query_id;
         $this->data['sort_by'] = $sort_by;
         $this->data['sort_order'] = $sort_order;
		
         //load the models
         $this->load->library('ion_auth');
	 $this->load->model('search_model');
		
         //set results to what is obtained in the search
         $results = $this->search_model->member_search_no_where_clause($category, $limit, $offset, $sort_by, $sort_order);
         
         //make into data to populate rows
         $this->data['membersforview'] = $results['rows'];
	 $this->data['num_results'] = $results['num_rows'];
         
         //pagenation
         $this->load->library('pagination');
         $config = array();
         $config['base_url'] = site_url("auth/activate/$query_id/$sort_by/$sort_order");
         $config['total_rows'] = $results['num_rows'];//$data['num_results'];
         $config['per_page'] = $limit;
         $config['uri_segment'] = 6;
         $this->pagination->initialize($config);
         $this->data['pagination'] = $this->pagination->create_links();
                    //End
         //show the view
         $this->showView('activate_user');
		}
		else
		{
				// do we have the right userlevel?
				if ($this->ion_auth->logged_in() && $this->ion_auth->is_admin())
				{
                                    //activate based on id
                                        $data = array(
				'activated' => 'Y'                              
			);

			
		        $this->ion_auth->update($user->id, $data);
                        
                        $this->ion_auth->activate($id);
                                }
			
                        //redirect them back to the auth page
                        $this->session->set_flashdata('member_activated', 'Member Id: '.$id. ' has been activated.');
			redirect('auth/activate', 'refresh');
                }
	}

	//deactivate the user
	function deactivate($query_id = 0, $sort_by = 'first_name', $sort_order = 'asc', $offset = 0)
	{
              
            //grab id from the input box
            $id = $this->input->post('deactivation_id');
            $user = $this->ion_auth->user($id)->row();
              
              //dropdown(note: not getting correct value
              //$id = $this->input->post('user_to_deactivate');
            
		$this->load->library('form_validation');
		//$this->form_validation->set_rules('confirm', $this->lang->line('deactivate_validation_confirm_label'), 'required');
		$this->form_validation->set_rules('deactivation_id', 'User ID', 'required|alpha_numeric');

		if ($this->form_validation->run() == FALSE)
		{
			// insert csrf check
			$this->data['csrf'] = $this->_get_csrf_nonce();
			$this->data['user'] = $this->ion_auth->user($id)->row();
                        
                        //Search Table Section
                    //Limit on items to show on table
        $limit = 5;
        
        //Values to Insert in Head of Table
	$this->data['fields'] = array(
                        'id'           => 'ID:',
			'first_name' => 'First Name:',
			'last_name' => 'Last Name:',
                        'email'      => 'Email:',
                        'company' => 'Company:',
                        'position' => 'Position:',
                        'country'  => 'Country:',
                        'activated' => 'Active:'
		);
                
        $category = 'first_name';
        //$a = '';
         
         $this->data['query_id'] = $query_id;
         $this->data['sort_by'] = $sort_by;
         $this->data['sort_order'] = $sort_order;
		
         //load the models
         $this->load->library('ion_auth');
	 $this->load->model('search_model');
		
         //set results to what is obtained in the search
         $results = $this->search_model->member_search_no_where_clause($category, $limit, $offset, $sort_by, $sort_order);
         
         //make into data to populate rows
         $this->data['membersforview'] = $results['rows'];
	 $this->data['num_results'] = $results['num_rows'];
         
         //pagenation
         $this->load->library('pagination');
         $config = array();
         $config['base_url'] = site_url("auth/activate/$query_id/$sort_by/$sort_order");
         $config['total_rows'] = $results['num_rows'];//$data['num_results'];
         $config['per_page'] = $limit;
         $config['uri_segment'] = 6;
         $this->pagination->initialize($config);
         $this->data['pagination'] = $this->pagination->create_links();
                    //End

			//$this->_render_page('auth/deactivate_user', $this->data);
                        //display edit_user view
                        $this->showView('activate_user');
		}
		else
		{
                   
				// do we have the right userlevel?
				if ($this->ion_auth->logged_in() && $this->ion_auth->is_admin())
				{
					$this->ion_auth->deactivate($id);
                                        $data = array(
				'activated' => 'N',                              
			);

			
		        $this->ion_auth->update($user->id, $data);
				}
		

			//redirect them back to the auth page
                        $this->session->set_flashdata('member_deactivated', 'Member Id: '.$id. ' has been deactivated.');
                        redirect('auth/deactivate', 'refresh');
		}
	}
        
        //saves an individuals information to later process
	function save_user()
	{
		$tables = $this->config->item('tables','ion_auth');
		
	//validate form input

		$this->form_validation->set_rules('first_name', 'First Name', 'required|xss_clean');
                $this->form_validation->set_rules('middle_initial', 'middle_initial', 'xss_clean');
		$this->form_validation->set_rules('last_name', 'Last Name', 'required|xss_clean');
		$this->form_validation->set_rules('email', $this->lang->line('create_user_validation_email_label'), 'required|valid_email|is_unique['.$tables['users'].'.email]');
		$this->form_validation->set_rules('phone', 'Phone', 'required|xss_clean');
		$this->form_validation->set_rules('company', 'Company', 'required|xss_clean');
		$this->form_validation->set_rules('password', 'password', 'required|min_length[' . $this->config->item('min_password_length', 'ion_auth') . ']|max_length[' . $this->config->item('max_password_length', 'ion_auth') . ']|matches[password_confirm]');
		$this->form_validation->set_rules('password_confirm', 'password Confirm', 'required');
                $this->form_validation->set_rules('biography', 'Biography', 'xss_clean');
                $this->form_validation->set_rules('position', 'Position', 'xss_clean|required');
                $this->form_validation->set_rules('website', 'Website', 'xss_clean');
                
                
                //address info
                $this->form_validation->set_rules('address', 'address', 'xss_clean');
                $this->form_validation->set_rules('city', 'city', 'xss_clean');
                $this->form_validation->set_rules('state', 'state', 'xss_clean');
                $this->form_validation->set_rules('zip', 'zip', 'xss_clean');
                $this->form_validation->set_rules('country', 'Country', 'xss_clean|required');
                
		if ($this->form_validation->run() == true)
		{
			$username = strtolower($this->input->post('first_name')) . '_' . strtolower($this->input->post('last_name'));
			$email    = strtolower($this->input->post('email'));
			$password = $this->input->post('password');

			$additional_data = array(
				'first_name' => $this->input->post('first_name'),
                                'middle_initial' => $this->input->post('middle_initial'),
				'last_name'  => $this->input->post('last_name'),
				'company'    => $this->input->post('company'),
				'phone'      => $this->input->post('phone'),
                                'biography'      => $this->input->post('biography'),
                            'address'      => $this->input->post('address'),
                            'city'      => $this->input->post('city'),
                            'state'      => $this->input->post('state'),
                            'zip'      => $this->input->post('zip'),
                            'position'      => $this->input->post('position'),
                            'country'      => $this->input->post('country'),
                            'website'      => $this->input->post('website'),
			);
                        
                        //pass to another method which will process the payment
                        $this->create_user($username, $email, $password, $additional_data);
		}
		
		else    //If needed fields not entered just save the info and refresh
		{
			//display the create user form
			//set the flash data error message if there is one
			$this->data['message'] = (validation_errors() ? validation_errors() : ($this->ion_auth->errors() ? $this->ion_auth->errors() : $this->session->flashdata('message')));

			$this->data['first_name'] = array(
				'name'  => 'first_name',
				'id'    => 'first_name',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('first_name'),
			);
                        $this->data['middle_initial'] = array(
				'name'  => 'middle_initial',
				'id'    => 'middle_initial',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('middle_initial'),
			);
			$this->data['last_name'] = array(
				'name'  => 'last_name',
				'id'    => 'last_name',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('last_name'),
			);
			$this->data['email'] = array(
				'name'  => 'email',
				'id'    => 'email',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('email'),
			);
			$this->data['company'] = array(
				'name'  => 'company',
				'id'    => 'company',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('company'),
			);
			$this->data['phone'] = array(
				'name'  => 'phone',
				'id'    => 'phone',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('phone'),
			);
			$this->data['password'] = array(
				'name'  => 'password',
				'id'    => 'password',
				'type'  => 'password',
				'value' => $this->form_validation->set_value('password'),
			);
			$this->data['password_confirm'] = array(
				'name'  => 'password_confirm',
				'id'    => 'password_confirm',
				'type'  => 'password',
				'value' => $this->form_validation->set_value('password_confirm'),
			);
                        $this->data['biography'] = array(
				'name'  => 'biography',
				'id'    => 'biography',
				'type'  => 'text',
                                'rows' => '5',
                                'cols' => '10',
				'value' => $this->form_validation->set_value('biography'),
			);
                        $this->data['address'] = array(
				'name'  => 'address',
				'id'    => 'address',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('address'),
			);
                        $this->data['city'] = array(
				'name'  => 'city',
				'id'    => 'city',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('city'),
			);
                        $this->data['state'] = array(
				'name'  => 'state',
				'id'    => 'state',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('state'),
			);
                        $this->data['zip'] = array(
				'name'  => 'zip',
				'id'    => 'zip',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('zip'),
			);
                        $this->data['position'] = array(
				'name'  => 'position',
				'id'    => 'position',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('position'),
			);
                        $this->data['country'] = array(
				'name'  => 'country',
				'id'    => 'country',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('country'),
			);
                        $this->data['website'] = array(
				'name'  => 'website',
				'id'    => 'website',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('website'),
			);

			//$this->_render_page('auth/save_user', $this->data);
                        //display edit_user view
                        $this->showView('register'); 
		}
	}
        
        //saves an individuals information to later process
	function save_company()
	{
		$tables = $this->config->item('tables','ion_auth');
		
	//validate form input
		$this->form_validation->set_rules('email', $this->lang->line('create_user_validation_email_label'), 'required|valid_email|is_unique['.$tables['users'].'.email]');
		$this->form_validation->set_rules('phone', 'Phone', 'required|xss_clean');
		$this->form_validation->set_rules('company', 'Company', 'required|xss_clean');
		$this->form_validation->set_rules('password', 'Password', 'required|min_length[' . $this->config->item('min_password_length', 'ion_auth') . ']|max_length[' . $this->config->item('max_password_length', 'ion_auth') . ']|matches[password_confirm]');
		$this->form_validation->set_rules('password_confirm', 'Password Confirm', 'required');
                $this->form_validation->set_rules('biography', 'Biography', 'xss_clean');
                $this->form_validation->set_rules('website', 'Website', 'xss_clean');
                
                
                //address info
                $this->form_validation->set_rules('address', 'address', 'xss_clean');
                $this->form_validation->set_rules('city', 'city', 'xss_clean');
                $this->form_validation->set_rules('state', 'state', 'xss_clean');
                $this->form_validation->set_rules('zip', 'zip', 'xss_clean');
                $this->form_validation->set_rules('country', 'Country', 'xss_clean|required');
		//$this->form_validation->set_rules('groups', $this->lang->line('edit_user_validation_groups_label'), 'xss_clean');
                
		if ($this->form_validation->run() == true)
		{
			$username = $this->input->post('company');
			$email    = strtolower($this->input->post('email'));
			$password = $this->input->post('password');

			$additional_data = array(
			'company'    => $this->input->post('company'),
			'phone'      => $this->input->post('phone'),
                        'biography'      => $this->input->post('biography'),
                            'address'      => $this->input->post('address'),
                            'city'      => $this->input->post('city'),
                            'state'      => $this->input->post('state'),
                            'zip'      => $this->input->post('zip'),
                            'country'      => $this->input->post('country'),
                            'website'      => $this->input->post('website'),
                            'listing'       => 'N',
                            'type' => 'C'
			);
                        
                        //pass to another method which will process the payment
                        $this->create_company($username, $email, $password, $additional_data);
		}
		
		else    //If needed fields not entered just save the info and refresh
		{
			//display the create user form
			//set the flash data error message if there is one
			$this->data['message'] = (validation_errors() ? validation_errors() : ($this->ion_auth->errors() ? $this->ion_auth->errors() : $this->session->flashdata('message')));

			
			$this->data['email'] = array(
				'name'  => 'email',
				'id'    => 'email',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('email'),
			);
			$this->data['company'] = array(
				'name'  => 'company',
				'id'    => 'company',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('company'),
			);
			$this->data['phone'] = array(
				'name'  => 'phone',
				'id'    => 'phone',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('phone'),
			);
			$this->data['password'] = array(
				'name'  => 'password',
				'id'    => 'password',
				'type'  => 'password',
				'value' => $this->form_validation->set_value('password'),
			);
			$this->data['password_confirm'] = array(
				'name'  => 'password_confirm',
				'id'    => 'password_confirm',
				'type'  => 'password',
				'value' => $this->form_validation->set_value('password_confirm'),
			);
                        $this->data['biography'] = array(
				'name'  => 'biography',
				'id'    => 'biography',
				'type'  => 'text',
                                'rows' => '5',
                                'cols' => '10',
				'value' => $this->form_validation->set_value('biography'),
			);
                        $this->data['address'] = array(
				'name'  => 'address',
				'id'    => 'address',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('address'),
			);
                        $this->data['city'] = array(
				'name'  => 'city',
				'id'    => 'city',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('city'),
			);
                        $this->data['state'] = array(
				'name'  => 'state',
				'id'    => 'state',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('state'),
			);
                        $this->data['zip'] = array(
				'name'  => 'zip',
				'id'    => 'zip',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('zip'),
			);
                        $this->data['country'] = array(
				'name'  => 'country',
				'id'    => 'country',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('country'),
			);
                        $this->data['website'] = array(
				'name'  => 'website',
				'id'    => 'website',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('website'),
			);

			//$this->_render_page('auth/create_user', $this->data);
                        //display edit_user view
                        $this->showView('register_company'); 
		}
	}
        
        	//create a new user
	function create_user($username = NULL, $email = NULL, $password = NULL, $additional_data = NULL)
	{   
            //pass username
            $this->data['username'] = $username;
            //pass email
            $this->data['email'] = $email;
            //pass password
            $this->data['password'] = $password;
            
            //additional 
                $this->data['first_name'] = $additional_data['first_name'];
                $this->data['last_name'] = $additional_data['last_name'];
                $this->data['company'] = $additional_data['company'];
                $this->data['phone'] = $additional_data['phone'];
                $this->data['middle_initial'] = $additional_data['middle_initial'];
                $this->data['address'] = $additional_data['address'];
                $this->data['city'] = $additional_data['city'];
                $this->data['state'] = $additional_data['state'];
                $this->data['zip'] = $additional_data['zip'];
                $this->data['biography'] = $additional_data['biography'];
                $this->data['position'] = $additional_data['position'];
                $this->data['country'] = $additional_data['country'];
                $this->data['website'] = $additional_data['website'];
                
                 $this->load->library('../controllers/payment');
                 $indiprice = $this->payment->get_individual_price();
                 $price = intval($indiprice);
                 
                 $listprice = $this->payment->get_listing_price();
                 $total = intval($indiprice) + intval($listprice);
                    
                 $this->data['price'] = $price;
                 $this->data['total'] = $total;
       
                 $this->showView('register_pass');
        }
        
        //create a new user
	function create_company($username = NULL, $email = NULL, $password = NULL, $additional_data = NULL)
	{   
            //pass username
            $this->data['username'] = $username;
            //pass email
            $this->data['email'] = $email;
            //pass password
            $this->data['password'] = $password;
            
            //additional 
               
                $this->data['company'] = $additional_data['company'];
                $this->data['phone'] = $additional_data['phone'];
                
                $this->data['address'] = $additional_data['address'];
                $this->data['city'] = $additional_data['city'];
                $this->data['state'] = $additional_data['state'];
                $this->data['zip'] = $additional_data['zip'];
                $this->data['biography'] = $additional_data['biography'];
               
                $this->data['country'] = $additional_data['country'];
                $this->data['website'] = $additional_data['website'];
                
                $this->load->library('../controllers/payment');
                $compprice = $this->payment->get_company_price();
                $price = intval($compprice);
                    
                $listprice = $this->payment->get_listing_price();
                $total = intval($compprice) + intval($listprice);
                    
                $this->data['price'] = $price;
                $this->data['total'] = $total;
                            
       
                $this->showView('register_company_pass');
        }
        
               public function create_Folder($email)
    {
        $username= strtolower($email);



        // create a members folder if doesnt exist.
        if (!is_dir('members')) 
        {
            mkdir('./members', 0777, true);
        }
        
        //create a members email folder inside member if doesnt exist
        if (!is_dir('members/'.$email)) 
        {
            mkdir('./members/'.$email, 0777, true);
        }
        
        if (!is_dir('members/'.$email.'/engine_listings')) 
        {
            mkdir('./members/'.$email.'/engine_listings', 0777, true);
        }
        
        if (!is_dir('members/'.$email.'/part_listings')) 
        {
            mkdir('./members/'.$email.'/part_listings', 0777, true);
        }
        
        if (!is_dir('members/'.$email.'/conference_listings')) 
        {
            mkdir('./members/'.$email.'/conference_listings', 0777, true);
        }
        
        if (!is_dir('members/'.$email.'/pictures')) 
        {
            mkdir('./members/'.$email.'/pictures', 0777, true);
        }
        
        
    }   
        
        
        //new
            function start()
               {
                    $username = $this->input->post('username');
                    $password = $this->input->post('password');
                    $email = $this->input->post('email');
                   
                    $end = date('Y-m-d', strtotime('+1 years'));
                    
                    $price = $this->input->post('price');
            
                    $additional_data = array(
				'first_name' => $this->input->post('first_name'),
                                'middle_initial' => $this->input->post('middle_initial'),
				'last_name'  => $this->input->post('last_name'),
				'company'    => $this->input->post('company'),
				'phone'      => $this->input->post('phone'),
                            'biography'      => $this->input->post('biography'),
                            'address'      => $this->input->post('address'),
                            'city'      => $this->input->post('city'),
                            'state'      => $this->input->post('state'),
                            'zip'      => $this->input->post('zip'),
                            'position'      => $this->input->post('position'),
                            'country'      => $this->input->post('country'),
                            'website'      => $this->input->post('website'),
                                'listing'               => 'N',
                                'type'                  => 'I',
                                'activated'              => 'Y',
                                'registration_end' => $end,
			);
                    
                     
    
                   //load payment library
                   $this->load->library( 'stripe' );
                    
                    
                   // Get the credit card details submitted by the form
                   $token = $_POST['stripeToken'];

                  
                   
                   // Create the charge on Stripe's servers - this will charge the user's card
                    try {
                        
                    
                        //attempt to charge user
                        $this->stripe->charge_card( intval($price), $token, "Individual Membership" );
                        } 
                        catch(Stripe_CardError $e) 
                        {
                          // The card has been declined
                        }
                   
                        
			//If passed then add a new user
                        //add the user
                        $this->ion_auth->register($username, $password, $email, $additional_data);
                        $this->create_Folder($email);
			$this->session->set_flashdata('message', 'Payment Successful');
                        
                      //TEST
                      //load parameters
                      //load parameters
                      $type = 'new account';
                      $date = date('Y-m-d');
                      date_default_timezone_set('America/New_York');
                      $time = date('h:i:s a', time());
                      //load the controller for adding activity
                      $this->load->library('../controllers/activity');
                      $this->activity->insert($email, $type, $date, $time);
                        
                        //send to login
                        //$this->showView('login');
			redirect("auth/login", 'refresh'); 
                     
         }
         
         //new
        function start_user_with_listing()
               {
                    $username = $this->input->post('username');
                    $password = $this->input->post('password');
                    $email = $this->input->post('email');
                   
                    $end = date('Y-m-d', strtotime('+1 years'));
                    
                    $price = $this->input->post('price_listing');
            
                    $additional_data = array(
				'first_name' => $this->input->post('first_name'),
                                'middle_initial' => $this->input->post('middle_initial'),
				'last_name'  => $this->input->post('last_name'),
				'company'    => $this->input->post('company'),
				'phone'      => $this->input->post('phone'),
                            'biography'      => $this->input->post('biography'),
                            'address'      => $this->input->post('address'),
                            'city'      => $this->input->post('city'),
                            'state'      => $this->input->post('state'),
                            'zip'      => $this->input->post('zip'),
                            'position'      => $this->input->post('position'),
                            'country'      => $this->input->post('country'),
                            'website'      => $this->input->post('website'),
                                'listing'               => 'Y',
                                'type'                  => 'I',
                        'activated'              => 'Y',
                                'registration_end' => $end,
			);
                    
                     
    
                   //load payment library
                   $this->load->library( 'stripe' );
                    
                    
                   // Get the credit card details submitted by the form
                   $token = $_POST['stripeToken'];

                  
                   
                   // Create the charge on Stripe's servers - this will charge the user's card
                    try {
                        
                    
                        //attempt to charge user
                        $this->stripe->charge_card( intval($price), $token, "Individual Membership" );
                        } 
                        catch(Stripe_CardError $e) 
                        {
                          // The card has been declined
                        }
                   
                        
			//If passed then add a new user
                        //add the user
                        $this->ion_auth->register($username, $password, $email, $additional_data);
                        $this->create_Folder($email);
			$this->session->set_flashdata('message', 'Payment Successful');
                        
                      //TEST
                      //load parameters
                     //load parameters
                      $type = 'new account';
                      $date = date('Y-m-d');
                      date_default_timezone_set('America/New_York');
                      $time = date('h:i:s a', time());
                      //load the controller for adding activity
                      $this->load->library('../controllers/activity');
                      $this->activity->insert($email, $type, $date, $time);
                        
                        //send to login
                        //$this->showView('login');
			redirect("auth/login", 'refresh');
                    
         }
         
         
         function start_comp()
               {
                    $username = $this->input->post('username');
                    $password = $this->input->post('password');
                    $email = $this->input->post('email');
                   
                    $end = date('Y-m-d', strtotime('+1 years'));
                    
                    $price = $this->input->post('price');
            
                    
                    $additional_data = array(
				'company'    => $this->input->post('company'),
				'phone'      => $this->input->post('phone'),
                            'biography'      => $this->input->post('biography'),
                            'address'      => $this->input->post('address'),
                            'city'      => $this->input->post('city'),
                            'state'      => $this->input->post('state'),
                            'zip'      => $this->input->post('zip'),
                            'country'      => $this->input->post('country'),
                            'website'      => $this->input->post('website'),
                                'listing'               => 'N',
                                'type'                  => 'C',
                        'activated'              => 'Y',
                                'registration_end' => $end,
			);
                    
                     
    
                   //load payment library
                   $this->load->library( 'stripe' );
                    
                    
                   // Get the credit card details submitted by the form
                   $token = $_POST['stripeToken'];

                  
                   
                   // Create the charge on Stripe's servers - this will charge the user's card
                    try {
                        
                    
                        //attempt to charge user
                        $this->stripe->charge_card( intval($price), $token, "Individual Membership" );
                        } 
                        catch(Stripe_CardError $e) 
                        {
                          // The card has been declined
                        }
                   
                        
			//If passed then add a new user
                        //add the user
                        $this->ion_auth->register($username, $password, $email, $additional_data);
                        $this->create_Folder($email);
			$this->session->set_flashdata('message', 'Payment Successful');
                        
                      //TEST
                      //load parameters
                     //load parameters
                      $type = 'new account';
                      $date = date('Y-m-d');
                      date_default_timezone_set('America/New_York');
                      $time = date('h:i:s a', time());
                      //load the controller for adding activity
                      $this->load->library('../controllers/activity');
                      $this->activity->insert($email, $type, $date, $time);
                        
                        //send to login
                        //$this->showView('login');
			redirect("auth/login", 'refresh');   
         }
         
         function start_comp_with_listing() 
               {
                    $username = $this->input->post('username');
                    $password = $this->input->post('password');
                    $email = $this->input->post('email');
                   
                    $end = date('Y-m-d', strtotime('+1 years'));
                    
                    $price = $this->input->post('price_listing');
            
                    
                    $additional_data = array(
				'company'    => $this->input->post('company'),
				'phone'      => $this->input->post('phone'),
                            'biography'      => $this->input->post('biography'),
                            'address'      => $this->input->post('address'),
                            'city'      => $this->input->post('city'),
                            'state'      => $this->input->post('state'),
                            'zip'      => $this->input->post('zip'),
                            'country'      => $this->input->post('country'),
                            'website'      => $this->input->post('website'),
                                'listing'               => 'Y',
                                'type'                  => 'C',
                        'activated'              => 'Y',
                                'registration_end' => $end,
			);
                    
                     
    
                   //load payment library
                   $this->load->library( 'stripe' );
                    
                    
                   // Get the credit card details submitted by the form
                   $token = $_POST['stripeToken'];

                  
                   
                   // Create the charge on Stripe's servers - this will charge the user's card
                    try {
                        
                    
                        //attempt to charge user
                        $this->stripe->charge_card( intval($price), $token, "Individual Membership" );
                        } 
                        catch(Stripe_CardError $e) 
                        {
                          // The card has been declined
                        }
                   
                        
			//If passed then add a new user
                        //add the user
                        $this->ion_auth->register($username, $password, $email, $additional_data);
                        $this->create_Folder($email);
			$this->session->set_flashdata('message', 'Payment Successful');
                        
                      //TEST
                      //load parameters
                      //load parameters
                      $type = 'new account';
                      $date = date('Y-m-d');
                      date_default_timezone_set('America/New_York');
                      $time = date('h:i:s a', time());
                      //load the controller for adding activity
                      $this->load->library('../controllers/activity');
                      $this->activity->insert($email, $type, $date, $time);
                        
                        //send to login
                        //$this->showView('login');
			redirect("auth/login", 'refresh');   
         }
         
         
         //saves an individuals information to later process
	function create_user_admin()
	{
		$tables = $this->config->item('tables','ion_auth');
		
	//validate form input

		$this->form_validation->set_rules('first_name', 'first_name', 'required|xss_clean');
                $this->form_validation->set_rules('middle_initial', 'middle_initial', 'xss_clean');
		$this->form_validation->set_rules('last_name', 'last_name', 'required|xss_clean');
		$this->form_validation->set_rules('email', $this->lang->line('create_user_validation_email_label'), 'required|valid_email|is_unique['.$tables['users'].'.email]');
		$this->form_validation->set_rules('phone', 'phone', 'required|xss_clean');
		$this->form_validation->set_rules('company', 'company', 'required|xss_clean');
		$this->form_validation->set_rules('password', 'password', 'required|min_length[' . $this->config->item('min_password_length', 'ion_auth') . ']|max_length[' . $this->config->item('max_password_length', 'ion_auth') . ']|matches[password_confirm]');
		$this->form_validation->set_rules('password_confirm', 'password_confirm', 'required');
                $this->form_validation->set_rules('biography', 'biography', 'xss_clean');
                $this->form_validation->set_rules('position', 'Position', 'xss_clean|required');
                $this->form_validation->set_rules('website', 'website', 'xss_clean');
                
                
                //address info
                $this->form_validation->set_rules('address', 'address', 'xss_clean');
                $this->form_validation->set_rules('city', 'city', 'xss_clean');
                $this->form_validation->set_rules('state', 'state', 'xss_clean');
                $this->form_validation->set_rules('zip', 'zip', 'xss_clean');
                $this->form_validation->set_rules('country', 'country', 'xss_clean|required');
		//$this->form_validation->set_rules('groups', $this->lang->line('edit_user_validation_groups_label'), 'xss_clean');
                
		if ($this->form_validation->run() == true)
		{
			$username = strtolower($this->input->post('first_name')) . '_' . strtolower($this->input->post('last_name'));
			$email    = strtolower($this->input->post('email'));
			$password = $this->input->post('password');

			$additional_data = array(
				'first_name' => $this->input->post('first_name'),
                                'middle_initial' => $this->input->post('first_name'),
				'last_name'  => $this->input->post('last_name'),
				'company'    => $this->input->post('company'),
				'phone'      => $this->input->post('phone'),
                                'biography'      => $this->input->post('biography'),
                            'address'      => $this->input->post('address'),
                            'city'      => $this->input->post('city'),
                            'state'      => $this->input->post('state'),
                            'zip'      => $this->input->post('zip'),
                            'position'      => $this->input->post('position'),
                            'country'      => $this->input->post('country'),
                            'website'      => $this->input->post('website'),
			);
                        
                        //add user data to db
                        $this->ion_auth->register($username, $password, $email, $additional_data);
		}
		
		else    //If needed fields not entered just save the info and refresh
		{
			//display the create user form
			//set the flash data error message if there is one
			$this->data['message'] = (validation_errors() ? validation_errors() : ($this->ion_auth->errors() ? $this->ion_auth->errors() : $this->session->flashdata('message')));

			$this->data['first_name'] = array(
				'name'  => 'first_name',
				'id'    => 'first_name',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('first_name'),
			);
                        $this->data['middle_initial'] = array(
				'name'  => 'middle_initial',
				'id'    => 'middle_initial',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('middle_initial'),
			);
			$this->data['last_name'] = array(
				'name'  => 'last_name',
				'id'    => 'last_name',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('last_name'),
			);
			$this->data['email'] = array(
				'name'  => 'email',
				'id'    => 'email',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('email'),
			);
			$this->data['company'] = array(
				'name'  => 'company',
				'id'    => 'company',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('company'),
			);
			$this->data['phone'] = array(
				'name'  => 'phone',
				'id'    => 'phone',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('phone'),
			);
			$this->data['password'] = array(
				'name'  => 'password',
				'id'    => 'password',
				'type'  => 'password',
				'value' => $this->form_validation->set_value('password'),
			);
			$this->data['password_confirm'] = array(
				'name'  => 'password_confirm',
				'id'    => 'password_confirm',
				'type'  => 'password',
				'value' => $this->form_validation->set_value('password_confirm'),
			);
                        $this->data['biography'] = array(
				'name'  => 'biography',
				'id'    => 'biography',
				'type'  => 'text',
                                'rows' => '5',
                                'cols' => '10',
				'value' => $this->form_validation->set_value('biography'),
			);
                        $this->data['address'] = array(
				'name'  => 'address',
				'id'    => 'address',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('address'),
			);
                        $this->data['city'] = array(
				'name'  => 'city',
				'id'    => 'city',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('city'),
			);
                        $this->data['state'] = array(
				'name'  => 'state',
				'id'    => 'state',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('state'),
			);
                        $this->data['zip'] = array(
				'name'  => 'zip',
				'id'    => 'zip',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('zip'),
			);
                        $this->data['position'] = array(
				'name'  => 'position',
				'id'    => 'position',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('position'),
			);
                        $this->data['country'] = array(
				'name'  => 'country',
				'id'    => 'country',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('country'),
			);
                        $this->data['website'] = array(
				'name'  => 'website',
				'id'    => 'website',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('website'),
			);

			//$this->_render_page('auth/create_user', $this->data);
                        //display edit_user view
                        $this->showView('create_user'); 
		}
	}

        //Added by Fernando Diaz
        //view your user profile
        function view_user()
        {
            $id = $this->ion_auth->get_user_id();
            $usern = $this->ion_auth->get_user_name();
            $user = $this->ion_auth->user($id)->row();
            
            if($user->type == 'C')
            {
                 $id = $this->ion_auth->get_user_id();
              
                //if not logged in redirect to login page
		//if (!$this->ion_auth->logged_in() || (!$this->ion_auth->is_admin() && !($this->ion_auth->user()->row()->id == $id)))
		if (!$this->ion_auth->logged_in())
                {
                        //redirect('auth', 'refresh');
			redirect('auth/login', 'refresh');
		}

		$user = $this->ion_auth->user($id)->row();
		
		//display the edit user form
		$this->data['csrf'] = $this->_get_csrf_nonce();

		//pass the user to the view
		$this->data['user'] = $user;
                
                //get data from $user which is all the items in a user's row
                //shown in: $user = $this->ion_auth->user($id)->row();
                $this->data['email'] = $user->email;
              
                $this->data['company'] = $user->company;
                $this->data['phone'] = $user->phone;
            
                $this->data['address'] = $user->address;
                $this->data['city'] = $user->city;
                $this->data['state'] = $user->state;
                $this->data['zip'] = $user->zip;
                $this->data['biography'] = $user->biography;
               
                $this->data['country'] = $user->country;
                $this->data['website'] = $user->website;
                
                $this->data['picture'] = $this->view_image();
                
                //display edit_user view
                 $this->showView('view_company');
            }
            else
            {
              $id = $this->ion_auth->get_user_id();
              
                //if not logged in redirect to login page
		//if (!$this->ion_auth->logged_in() || (!$this->ion_auth->is_admin() && !($this->ion_auth->user()->row()->id == $id)))
		if (!$this->ion_auth->logged_in())
                {
                        //redirect('auth', 'refresh');
			redirect('auth/login', 'refresh');
		}

		$user = $this->ion_auth->user($id)->row();
		//$groups=$this->ion_auth->groups()->result_array();
		//$currentGroups = $this->ion_auth->get_users_groups($id)->result();
          
		//display the edit user form
		$this->data['csrf'] = $this->_get_csrf_nonce();

		//pass the user to the view
		$this->data['user'] = $user;
                
                //get data from $user which is all the items in a user's row
                //shown in: $user = $this->ion_auth->user($id)->row();
                $this->data['first_name'] = $user->first_name;
                $this->data['email'] = $user->email;
                $this->data['last_name'] = $user->last_name;
                $this->data['company'] = $user->company;
                $this->data['phone'] = $user->phone;
                $this->data['middle_initial'] = $user->middle_initial;
                $this->data['address'] = $user->address;
                $this->data['city'] = $user->city;
                $this->data['state'] = $user->state;
                $this->data['zip'] = $user->zip;
                $this->data['biography'] = $user->biography;
                $this->data['position'] = $user->position;
                $this->data['country'] = $user->country;
                $this->data['website'] = $user->website;
                
                $this->data['picture'] = $this->view_image();
                
                //display edit_user view
                 $this->showView('view_user');
            }
        }
        
        //Added by Fernando Diaz
        //view your user profile
        function view_other_user($input)
        {
              //id is the current user's id number grabbed by the session
              //$id = '1';
              $id = $input;//$this->input->post('member_id');
              $user = $this->ion_auth->user($id)->row();
            
            if($user->type == 'C')
            {
                 $id = $this->ion_auth->get_user_id();
              
                //if not logged in redirect to login page
		//if (!$this->ion_auth->logged_in() || (!$this->ion_auth->is_admin() && !($this->ion_auth->user()->row()->id == $id)))
		if (!$this->ion_auth->logged_in())
                {
                        //redirect('auth', 'refresh');
			redirect('auth/login', 'refresh');
		}

		$user = $this->ion_auth->user($id)->row();
		
		//display the edit user form
		$this->data['csrf'] = $this->_get_csrf_nonce();

		//pass the user to the view
		$this->data['user'] = $user;
                
                //get data from $user which is all the items in a user's row
                //shown in: $user = $this->ion_auth->user($id)->row();
                $this->data['email'] = $user->email;
              
                $this->data['company'] = $user->company;
                $this->data['phone'] = $user->phone;
            
                $this->data['address'] = $user->address;
                $this->data['city'] = $user->city;
                $this->data['state'] = $user->state;
                $this->data['zip'] = $user->zip;
                $this->data['biography'] = $user->biography;
               
                $this->data['country'] = $user->country;
                $this->data['website'] = $user->website;
                
                $this->data['picture'] = $this->view_other_image($id);
                
                //display edit_user view
                 $this->showView('view_other_company');
            }
            else
            {
              
                //if not logged in redirect to login page
		//if (!$this->ion_auth->logged_in() || (!$this->ion_auth->is_admin() && !($this->ion_auth->user()->row()->id == $id)))
		if (!$this->ion_auth->logged_in())
                {
                        //redirect('auth', 'refresh');
			redirect('auth/login', 'refresh');
		}

		$user = $this->ion_auth->user($id)->row();
		//$groups=$this->ion_auth->groups()->result_array();
		//$currentGroups = $this->ion_auth->get_users_groups($id)->result();
          
		//display the edit user form
		$this->data['csrf'] = $this->_get_csrf_nonce();

		//pass the user to the view
		$this->data['user'] = $user;
                
                //get data from $user which is all the items in a user's row
                //shown in: $user = $this->ion_auth->user($id)->row();
                $this->data['first_name'] = $user->first_name;
                $this->data['email'] = $user->email;
                $this->data['last_name'] = $user->last_name;
                $this->data['company'] = $user->company;
                $this->data['phone'] = $user->phone;
                $this->data['middle_initial'] = $user->middle_initial;
                $this->data['address'] = $user->address;
                $this->data['city'] = $user->city;
                $this->data['state'] = $user->state;
                $this->data['zip'] = $user->zip;
                $this->data['biography'] = $user->biography;
                $this->data['position'] = $user->position;
                $this->data['country'] = $user->country;
                $this->data['website'] = $user->website;
                
                $this->data['picture'] = $this->view_other_image($id);
                
                //display edit_user view
                 $this->showView('view_other_user');
            }
        }
        
	//edit a user
	//function edit_user($id)
        function edit_user()
	{
       
            $id = $this->ion_auth->get_user_id();
             $user = $this->ion_auth->user($id)->row();
            
            if($user->type == 'C')
            {
                 //if not logged in redirect to login page
		//if (!$this->ion_auth->logged_in() || (!$this->ion_auth->is_admin() && !($this->ion_auth->user()->row()->id == $id)))
               if (!$this->ion_auth->logged_in())
		{
                        //redirect('auth', 'refresh');
			redirect('auth/login', 'refresh');
		}

		$user = $this->ion_auth->user($id)->row();
		//$groups=$this->ion_auth->groups()->result_array();
		//$currentGroups = $this->ion_auth->get_users_groups($id)->result();

		//validate form input

		
		//$this->form_validation->set_rules('email', $this->lang->line('create_user_validation_email_label'), 'required|valid_email|is_unique['.$tables['users'].'.email]');
		$this->form_validation->set_rules('phone', 'phone', 'required|xss_clean');
		$this->form_validation->set_rules('company', 'company', 'required|xss_clean');
		//$this->form_validation->set_rules('password', 'password', 'required|min_length[' . $this->config->item('min_password_length', 'ion_auth') . ']|max_length[' . $this->config->item('max_password_length', 'ion_auth') . ']|matches[password_confirm]');
		//$this->form_validation->set_rules('password_confirm', 'password_confirm', 'required');
                $this->form_validation->set_rules('biography', 'biography', 'xss_clean');
              
                $this->form_validation->set_rules('website', 'website', 'xss_clean');
                
                
                //address info
                $this->form_validation->set_rules('address', 'address', 'xss_clean');
                $this->form_validation->set_rules('city', 'city', 'xss_clean');
                $this->form_validation->set_rules('state', 'state', 'xss_clean');
                $this->form_validation->set_rules('zip', 'zip', 'xss_clean');
                $this->form_validation->set_rules('country', 'country', 'xss_clean|required');
		//$this->form_validation->set_rules('groups', $this->lang->line('edit_user_validation_groups_label'), 'xss_clean');
                
                //add the rest of the things
		if (isset($_POST) && !empty($_POST))
		{
			// do we have a valid request?
			if ($this->_valid_csrf_nonce() === FALSE || $id != $this->input->post('id'))
			{
				show_error($this->lang->line('error_csrf'));
			}

			$data = array(
				'company'      => $this->input->post('company'),
				'phone'      => $this->input->post('phone'),
                            'biography'      => $this->input->post('biography'),
                            'address'      => $this->input->post('address'),
                            'city'      => $this->input->post('city'),
                            'state'      => $this->input->post('state'),
                            'zip'      => $this->input->post('zip'),
                            
                            'country'      => $this->input->post('country'),
                            'website'      => $this->input->post('website'),
                            
			);

			if ($this->form_validation->run() === TRUE)
			{
				$this->ion_auth->update($user->id, $data);

				//check to see if we are creating the user
				//redirect them back to the admin page
				$this->session->set_flashdata('message', "User Saved");
				if ($this->ion_auth->is_admin() || $this->ion_auth->logged_in())
				{
                                        //change to view user
					redirect('auth/view_user', 'refresh');
				}
				else
				{
                                        //echo validation_errors(); 
					redirect('/', 'refresh');
				}
			}
		}

		//display the edit user form
		$this->data['csrf'] = $this->_get_csrf_nonce();

		//set the flash data error message if there is one
		$this->data['message'] = (validation_errors() ? validation_errors() : ($this->ion_auth->errors() ? $this->ion_auth->errors() : $this->session->flashdata('message')));

		//pass the user to the view
		$this->data['user'] = $user;
		//$this->data['groups'] = $groups;
		//$this->data['currentGroups'] = $currentGroups;
		$this->data['company'] = array(
			'name'  => 'company',
			'id'    => 'company',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('company', $user->company),
		);
		$this->data['phone'] = array(
			'name'  => 'phone',
			'id'    => 'phone',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('phone', $user->phone),
		);
                $this->data['biography'] = array(
			'name'  => 'biography',
			'id'    => 'biography',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('biography', $user->biography),
		);
                $this->data['address'] = array(
			'name'  => 'address',
			'id'    => 'address',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('address', $user->address),
		);
                $this->data['city'] = array(
			'name'  => 'city',
			'id'    => 'city',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('city', $user->city),
		);
                $this->data['state'] = array(
			'name'  => 'state',
			'id'    => 'state',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('state', $user->state),
		);
                $this->data['zip'] = array(
			'name'  => 'zip',
			'id'    => 'zip',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('zip', $user->zip),
		);
                        $this->data['country'] = array(
				'name'  => 'country',
				'id'    => 'country',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('country', $user->country),
			);
                        $this->data['website'] = array(
				'name'  => 'website',
				'id'    => 'website',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('website', $user->website),
			);
		//$this->_render_page('auth/edit_user', $this->data);
                
                //display edit_user view
                 $this->showView('edit_company');
                 
            }
            else
            {
                         
                //if not logged in redirect to login page
		//if (!$this->ion_auth->logged_in() || (!$this->ion_auth->is_admin() && !($this->ion_auth->user()->row()->id == $id)))
               if (!$this->ion_auth->logged_in())
		{
                        //redirect('auth', 'refresh');
			redirect('auth/login', 'refresh');
		}

		$user = $this->ion_auth->user($id)->row();
		//$groups=$this->ion_auth->groups()->result_array();
		//$currentGroups = $this->ion_auth->get_users_groups($id)->result();
        
		//validate form input

		$this->form_validation->set_rules('first_name', 'first_name', 'required|xss_clean');
                $this->form_validation->set_rules('middle_initial', 'middle_initial', 'xss_clean');
		$this->form_validation->set_rules('last_name', 'last_name', 'required|xss_clean');
		//$this->form_validation->set_rules('email', $this->lang->line('create_user_validation_email_label'), 'required|valid_email|is_unique['.$tables['users'].'.email]');
		$this->form_validation->set_rules('phone', 'phone', 'required|xss_clean');
		$this->form_validation->set_rules('company', 'company', 'required|xss_clean');
		//$this->form_validation->set_rules('password', 'password', 'required|min_length[' . $this->config->item('min_password_length', 'ion_auth') . ']|max_length[' . $this->config->item('max_password_length', 'ion_auth') . ']|matches[password_confirm]');
		//$this->form_validation->set_rules('password_confirm', 'password_confirm', 'required');
                $this->form_validation->set_rules('biography', 'biography', 'xss_clean');
                $this->form_validation->set_rules('position', 'Position', 'xss_clean|required');
                $this->form_validation->set_rules('website', 'website', 'xss_clean');
                $this->form_validation->set_rules('userfile', 'Mini Pack', 'callback__editfile_validation', 'xss_clean');
                
                
                //address info
                $this->form_validation->set_rules('address', 'address', 'xss_clean');
                $this->form_validation->set_rules('city', 'city', 'xss_clean');
                $this->form_validation->set_rules('state', 'state', 'xss_clean');
                $this->form_validation->set_rules('zip', 'zip', 'xss_clean');
                $this->form_validation->set_rules('country', 'country', 'xss_clean|required');
		//$this->form_validation->set_rules('groups', $this->lang->line('edit_user_validation_groups_label'), 'xss_clean');
                
                //add the rest of the things
		if (isset($_POST) && !empty($_POST))
		{
			// do we have a valid request?
			if ($this->_valid_csrf_nonce() === FALSE || $id != $this->input->post('id'))
			{
				show_error($this->lang->line('error_csrf'));
			}

			$data = array(
				'first_name' => $this->input->post('first_name'),
                                'middle_initial' => $this->input->post('middle_initial'),
				'last_name'  => $this->input->post('last_name'),
				'company'    => $this->input->post('company'),
				'phone'      => $this->input->post('phone'),
                            'biography'      => $this->input->post('biography'),
                            'address'      => $this->input->post('address'),
                            'city'      => $this->input->post('city'),
                            'state'      => $this->input->post('state'),
                            'zip'      => $this->input->post('zip'),
                            'position'      => $this->input->post('position'),
                            'country'      => $this->input->post('country'),
                            'website'      => $this->input->post('website'),
                            
			);

			if ($this->form_validation->run() === TRUE)
			{
				$this->ion_auth->update($user->id, $data);
                                //add picture
                                //$this->_editfile_validation($userfile);
                                

				//check to see if we are creating the user
				//redirect them back to the admin page
				$this->session->set_flashdata('message', "User Saved");
				if ($this->ion_auth->is_admin() || $this->ion_auth->logged_in())
				{
                                        //change to view user
					redirect('auth/view_user', 'refresh');
				}
				else
				{
                                        //echo validation_errors(); 
					redirect('/', 'refresh');
				}
			}
		}

		//display the edit user form
		$this->data['csrf'] = $this->_get_csrf_nonce();

		//set the flash data error message if there is one
		$this->data['message'] = (validation_errors() ? validation_errors() : ($this->ion_auth->errors() ? $this->ion_auth->errors() : $this->session->flashdata('message')));

		//pass the user to the view
		$this->data['user'] = $user;
		//$this->data['groups'] = $groups;
		//$this->data['currentGroups'] = $currentGroups;

		$this->data['first_name'] = array(
			'name'  => 'first_name',
			'id'    => 'first_name',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('first_name', $user->first_name),
		);
                $this->data['middle_initial'] = array(
			'name'  => 'middle_initial',
			'id'    => 'middle_initial',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('middle_initial', $user->middle_initial),
		);
		$this->data['last_name'] = array(
			'name'  => 'last_name',
			'id'    => 'last_name',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('last_name', $user->last_name),
		);
		$this->data['company'] = array(
			'name'  => 'company',
			'id'    => 'company',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('company', $user->company),
		);
		$this->data['phone'] = array(
			'name'  => 'phone',
			'id'    => 'phone',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('phone', $user->phone),
		);
                $this->data['biography'] = array(
			'name'  => 'biography',
			'id'    => 'biography',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('biography', $user->biography),
		);
                $this->data['address'] = array(
			'name'  => 'address',
			'id'    => 'address',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('address', $user->address),
		);
                $this->data['city'] = array(
			'name'  => 'city',
			'id'    => 'city',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('city', $user->city),
		);
                $this->data['state'] = array(
			'name'  => 'state',
			'id'    => 'state',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('state', $user->state),
		);
                $this->data['zip'] = array(
			'name'  => 'zip',
			'id'    => 'zip',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('zip', $user->zip),
		);
                   $this->data['position'] = array(
				'name'  => 'position',
				'id'    => 'position',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('position', $user->position),
			);
                        $this->data['country'] = array(
				'name'  => 'country',
				'id'    => 'country',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('country', $user->country),
			);
                        $this->data['website'] = array(
				'name'  => 'website',
				'id'    => 'website',
				'type'  => 'text',
                                'value' => $this->form_validation->set_value('website', $user->website),
			);
		//$this->_render_page('auth/edit_user', $this->data);
                
                //display edit_user view
                 $this->showView('edit_user');
            }
	}
        
        //fix this
        public function view_image()
    {
            $id = $this->ion_auth->get_user_id();
            $user = $this->ion_auth->user($id)->row();
            $email = $user->email;
            
            $pic1 = $this->ion_auth->get_picture($id);
            $pic2 = $pic1['rows'];
            $pic3 = $pic2['0'];
            $pic4 = $pic3->picture;
            
            if ($pic4 == '') {
            $path = '../res/images/nopic.gif';

            //return $path;
        } else {
            $path = '/aeroenginecloud/members/' . $email . '/pictures/' . $pic4;
        }
        return $path;
    }
    
    public function view_other_image($id)
    {
            //$id = $this->ion_auth->get_user_id();
            $user = $this->ion_auth->user($id)->row();
            $email = $user->email;
            
            $pic1 = $this->ion_auth->get_picture($id);
            $pic2 = $pic1['rows'];
            $pic3 = $pic2['0'];
            $pic4 = $pic3->picture;
            
            $path = '/aeroenginecloud/members/'.$email.'/pictures/'.$pic4;
         
            //print_r($path);
         return $path;
    }
        
        public function _editfile_validation() 
        {   
        $id1 = $this->ion_auth->get_user_id();
        $user1 = $this->ion_auth->user($id1)->row();
        $em1 = $user1->email;

        //set the path where the files uploaded will be copied
        $config['upload_path'] = './members/'.$em1.'/pictures/';

        // set the filter image types
        $config['allowed_types'] = 'gif|jpg|png|jpeg';
        
        //load the upload library
        $this->load->library('upload', $config);

        if (isset($_FILES['userfile']) && !empty($_FILES['userfile']['name'])) {
            
            delete_files('./members/'.$em1.'/pictures/');
            
             if (!$this->upload->do_upload('userfile')) 
            {
                $this->form_validation->set_message('_editfile_validation', 'Invalid Format. Type of format allowed: gif,jpg,pnf,jpeg.');
                return FALSE;
            } 
            else 
            {
                $this->data['upload_data'] = $this->upload->data();
                $this->ion_auth->set_picture($_FILES["userfile"]["name"], $id1);
                return TRUE;
            }
        } 
        else 
        {
            return TRUE;
        }
    }

	// create a new group
	function create_group()
	{
		$this->data['title'] = $this->lang->line('create_group_title');

		if (!$this->ion_auth->logged_in() || !$this->ion_auth->is_admin())
		{
			redirect('auth', 'refresh');
		}

		//validate form input
		$this->form_validation->set_rules('group_name', $this->lang->line('create_group_validation_name_label'), 'required|alpha_dash|xss_clean');
		$this->form_validation->set_rules('description', $this->lang->line('create_group_validation_desc_label'), 'xss_clean');

		if ($this->form_validation->run() == TRUE)
		{
			$new_group_id = $this->ion_auth->create_group($this->input->post('group_name'), $this->input->post('description'));
			if($new_group_id)
			{
				// check to see if we are creating the group
				// redirect them back to the admin page
				$this->session->set_flashdata('message', $this->ion_auth->messages());
				redirect("auth", 'refresh');
			}
		}
		else
		{
			//display the create group form
			//set the flash data error message if there is one
			$this->data['message'] = (validation_errors() ? validation_errors() : ($this->ion_auth->errors() ? $this->ion_auth->errors() : $this->session->flashdata('message')));

			$this->data['group_name'] = array(
				'name'  => 'group_name',
				'id'    => 'group_name',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('group_name'),
			);
			$this->data['description'] = array(
				'name'  => 'description',
				'id'    => 'description',
				'type'  => 'text',
				'value' => $this->form_validation->set_value('description'),
			);

			$this->_render_page('auth/create_group', $this->data);
		}
	}

	//edit a group
	function edit_group($id)
	{
		// bail if no group id given
		if(!$id || empty($id))
		{
			redirect('auth', 'refresh');
		}

		$this->data['title'] = $this->lang->line('edit_group_title');

		if (!$this->ion_auth->logged_in() || !$this->ion_auth->is_admin())
		{
			redirect('auth', 'refresh');
		}

		$group = $this->ion_auth->group($id)->row();

		//validate form input
		$this->form_validation->set_rules('group_name', $this->lang->line('edit_group_validation_name_label'), 'required|alpha_dash|xss_clean');
		$this->form_validation->set_rules('group_description', $this->lang->line('edit_group_validation_desc_label'), 'xss_clean');

		if (isset($_POST) && !empty($_POST))
		{
			if ($this->form_validation->run() === TRUE)
			{
				$group_update = $this->ion_auth->update_group($id, $_POST['group_name'], $_POST['group_description']);

				if($group_update)
				{
					$this->session->set_flashdata('message', $this->lang->line('edit_group_saved'));
				}
				else
				{
					$this->session->set_flashdata('message', $this->ion_auth->errors());
				}
				redirect("auth", 'refresh');
			}
		}

		//set the flash data error message if there is one
		$this->data['message'] = (validation_errors() ? validation_errors() : ($this->ion_auth->errors() ? $this->ion_auth->errors() : $this->session->flashdata('message')));

		//pass the user to the view
		$this->data['group'] = $group;

		$this->data['group_name'] = array(
			'name'  => 'group_name',
			'id'    => 'group_name',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('group_name', $group->name),
		);
		$this->data['group_description'] = array(
			'name'  => 'group_description',
			'id'    => 'group_description',
			'type'  => 'text',
			'value' => $this->form_validation->set_value('group_description', $group->description),
		);

		$this->_render_page('auth/edit_group', $this->data);
	}
        
         function changeType($query_id = 0, $sort_by = 'first_name', $sort_order = 'asc', $offset = 0)
	{
            //grab id from the input box
            $id = $this->input->post('activation_id');
              
             $category_options = array("Enable Listings", "Disable Listings");
             $this->data['category_options'] = $category_options;
             
             //get value in category
            $category = $this->input->post('category');
            $selectedItem = 'N';
      
           //set according to what is selected
           if($category == 0)
           {
            $selectedItem = 'Y';
           }
          else if($category == 1)
          {
            $selectedItem = 'N';
          }
            
            //$this->load->library('form_validation');
		//$this->form_validation->set_rules('confirm', $this->lang->line('deactivate_validation_confirm_label'), 'required');
		$this->form_validation->set_rules('activation_id', 'User ID', 'required|alpha_numeric');
                
            if ($this->form_validation->run() == FALSE)
		{
			// insert csrf check
			$this->data['csrf'] = $this->_get_csrf_nonce();
			$this->data['user'] = $this->ion_auth->user($id)->row();

                        
                                //Search Table Section
                    //Limit on items to show on table
        $limit = 5;
        
        //Values to Insert in Head of Table, add type
	$this->data['fields'] = array(
			'id' => 'ID:',
			'first_name' => 'First Name:',
			'last_name' => 'Last Name:',
                        'company' => 'Company:',
                        'position' => 'Position:',
                        'country'  => 'Country:',
                        'listing' => 'Listing:'
		);
                
        $category = 'first_name';
        //$a = '';
         
         $this->data['query_id'] = $query_id;
         $this->data['sort_by'] = $sort_by;
         $this->data['sort_order'] = $sort_order;
		
         //load the models
         $this->load->library('ion_auth');
	 $this->load->model('search_model');
		
         //set results to what is obtained in the search
         $results = $this->search_model->member_search_no_where_clause($category, $limit, $offset, $sort_by, $sort_order);
         
         //make into data to populate rows
         $this->data['membersforview'] = $results['rows'];
	 $this->data['num_results'] = $results['num_rows'];
         
         //pagenation
         $this->load->library('pagination');
         $config = array();
         $config['base_url'] = site_url("auth/changeType/$query_id/$sort_by/$sort_order");
         $config['total_rows'] = $results['num_rows'];//$data['num_results'];
         $config['per_page'] = $limit;
         $config['uri_segment'] = 6;
         $this->pagination->initialize($config);
         $this->data['pagination'] = $this->pagination->create_links();
                    //End
         //show the view
         $this->showView('change_type');
		}
		else
		{
				// do we have the right userlevel?
				if ($this->ion_auth->logged_in() && $this->ion_auth->is_admin())
				{
                                   //change the type of user to what is in the category changetype(id, selectedItem)
                                     $this->load->library('../controllers/search');
                                     $this->search->changeType($id, $selectedItem);
                      
				}
			
                        //redirect them back to the auth page
                        $this->session->set_flashdata('usertype_updated', 'Member Id: '.$id. ' has been updated.');        
			redirect('auth/changeType', 'refresh');
                               
                }
	}


	function _get_csrf_nonce()
	{
		$this->load->helper('string');
		$key   = random_string('alnum', 8);
		$value = random_string('alnum', 20);
		$this->session->set_flashdata('csrfkey', $key);
		$this->session->set_flashdata('csrfvalue', $value);

		return array($key => $value);
	}

	function _valid_csrf_nonce()
	{
		if ($this->input->post($this->session->flashdata('csrfkey')) !== FALSE &&
			$this->input->post($this->session->flashdata('csrfkey')) == $this->session->flashdata('csrfvalue'))
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}

	function _render_page($view, $data=null, $render=false)
	{

		$this->viewdata = (empty($data)) ? $this->data: $data;

		$view_html = $this->load->view($view, $this->viewdata, $render);

		if (!$render) return $view_html;
	}

}
